function [c1hat, CI, CIwidth, exitflag]=cutoffCIs(x,y,CItype,init)
xor=x;yor=y;n1=length(x);n2=length(y);
xor1=x;xor2=y;nx=length(x);ny=length(y);
epan=1;
exitflag=1;
ties=[];

rand('twister', 5493);
      randn('state', 3);
      randn('seed',3);
      rand('seed',3);
      
switch CItype
    case 'Delta'  %1
        
        
        
        nx=length(x);
        ny=length(y);
        [mx sx]=normfit(x);
        [my sy]=normfit(y);         
        a=my-mx;
        b=sy/sx;
        c=(mx*(b^2-1)-a+b*sqrt(a^2+(b^2-1)*sx^2*log(b^2)))/(b^2-1);

        Jhat=normcdf((my-c)/sy)+normcdf((c-mx)/sx)-1;
        Jmc(epan)=Jhat;

       
        %Schisterman's variances:
             
        S11=sx^2/nx;  
        S22=sx^2./(2.*(nx-1)); 
        S33=sy^2/ny; 
        S44=sy^2./(2.*(ny-1));
        
        
        S=[S11 0   0   0;
            0   S22 0   0;
            0   0   S33 0;
            0   0   0   S44]
        %S=inv(I);

s1hat=sx;
s2hat=sy;
m1hat=mx;
m2hat=my;

%----Estimate the two thresholds based on binormality:
b=s2hat/s1hat;
a=m2hat-m1hat;
c1hat=(m1hat*(b^2-1)-a+b*sqrt(a^2+(b^2-1)*s1hat^2*log(b^2)))./(b.^2-1);
 
dc1m1 =(s2hat^2/s1hat^2 + (s2hat*(2*m1hat - 2*m2hat))/(2*s1hat*((m1hat - m2hat)^2 + s1hat^2*log(s2hat^2/s1hat^2)*(s2hat^2/s1hat^2 - 1))^(1/2)))/(s2hat^2/s1hat^2 - 1)
dc1s1 =(2*s2hat^2*(m1hat - m2hat + m1hat*(s2hat^2/s1hat^2 - 1) + (s2hat*((m1hat - m2hat)^2 + s1hat^2*log(s2hat^2/s1hat^2)*(s2hat^2/s1hat^2 - 1))^(1/2))/s1hat))/(s1hat^3*(s2hat^2/s1hat^2 - 1)^2) - ((s2hat*((m1hat - m2hat)^2 + s1hat^2*log(s2hat^2/s1hat^2)*(s2hat^2/s1hat^2 - 1))^(1/2))/s1hat^2 + (2*m1hat*s2hat^2)/s1hat^3 + (s2hat*(2*s1hat*(s2hat^2/s1hat^2 - 1) + (2*s2hat^2*log(s2hat^2/s1hat^2))/s1hat - 2*s1hat*log(s2hat^2/s1hat^2)*(s2hat^2/s1hat^2 - 1)))/(2*s1hat*((m1hat - m2hat)^2 + s1hat^2*log(s2hat^2/s1hat^2)*(s2hat^2/s1hat^2 - 1))^(1/2)))/(s2hat^2/s1hat^2 - 1)
dc1m2 =-((s2hat*(2*m1hat - 2*m2hat))/(2*s1hat*((m1hat - m2hat)^2 + s1hat^2*log(s2hat^2/s1hat^2)*(s2hat^2/s1hat^2 - 1))^(1/2)) + 1)/(s2hat^2/s1hat^2 - 1)
dc1s2 =(((m1hat - m2hat)^2 + s1hat^2*log(s2hat^2/s1hat^2)*(s2hat^2/s1hat^2 - 1))^(1/2)/s1hat + (2*m1hat*s2hat)/s1hat^2 + (s2hat*(2*s2hat*log(s2hat^2/s1hat^2) + (2*s1hat^2*(s2hat^2/s1hat^2 - 1))/s2hat))/(2*s1hat*((m1hat - m2hat)^2 + s1hat^2*log(s2hat^2/s1hat^2)*(s2hat^2/s1hat^2 - 1))^(1/2)))/(s2hat^2/s1hat^2 - 1) - (2*s2hat*(m1hat - m2hat + m1hat*(s2hat^2/s1hat^2 - 1) + (s2hat*((m1hat - m2hat)^2 + s1hat^2*log(s2hat^2/s1hat^2)*(s2hat^2/s1hat^2 - 1))^(1/2))/s1hat))/(s1hat^2*(s2hat^2/s1hat^2 - 1)^2)

Vc1=S(1:4,1:4);
varc1=[dc1m1 dc1s1 dc1m2 dc1s2]*Vc1*[dc1m1 dc1s1 dc1m2 dc1s2]';
c1MC=c1hat;

CI=[c1MC-1.96*sqrt(varc1)  c1MC+1.96*sqrt(varc1)]

        Jhat;
        CIwidth=max(CI)-min(CI);

        
        
        
    case 'BC' %2
            xor=x;yor=y;
           
        
            [mx sx]=normfit(x);
            [my sy]=normfit(y);
            [transx1 transx2 lam exitflag]=boxcoxleo(xor,yor);
            [S]=COVlam(xor,yor);
            lamhat(epan)=lam;

            %estimate parameters for the transformed data:
            mx=mean(transx1);
            my=mean(transx2);
            sx=sqrt(var(transx1));
            sy=sqrt(var(transx2));
            a=my-mx;
            b=sy/sx;
            c=(mx*(b^2-1)-a+b*sqrt(a^2+(b^2-1)*sx^2*log(b^2)))/(b^2-1);
            c1hat=c;
            boots=1;
            while boots<=400
           
                if boots==100 || boots==200 || boots==300
                    boots
                end
    
                ata=randsample(1:n1,n1,'true');
                atb=randsample(1:n2,n2,'true');
    
                [transx1_boots transx2_boots lam_boots exitflag]=boxcoxleo(xor1(ata),xor2(atb));
                
                
    
                %estimate parameters for the transformed data:
                m1hat_boots=mean(transx1_boots);
                m2hat_boots=mean(transx2_boots);
                s1hat_boots=sqrt(var(transx1_boots));
                s2hat_boots=sqrt(var(transx2_boots));

                %----Estimate thresholds in box-cox scale:
                b=s2hat_boots/s1hat_boots;
                a=m2hat_boots-m1hat_boots;  
                c1hat_boots(boots)=(m1hat_boots*(b^2-1)-a+b*sqrt(a^2+(b^2-1)*s1hat_boots^2*log(b^2)))./(b.^2-1);
                c1hat_boots_or(boots)  = ((c1hat_boots(boots).*lam_boots+1)).^(1/lam_boots);

                [boots lam_boots exitflag c1hat_boots_or(boots)];
                
                if exitflag==1
                boots=boots+1;
                end
    
    
            end
                varboots(epan)=var(c1hat_boots_or);
                ccc=((c1hat.*lam+1)).^(1/lam)
                CI=[ccc-1.96*sqrt(var(c1hat_boots_or))  ccc+1.96*sqrt(var(c1hat_boots_or))];
                
                CIwidth=max(CI)-min(CI);
                CIf=CI;
                CIfwidth=CIwidth;
                
                c1hat=ccc;
            
                CI=[prctile(c1hat_boots_or,2.5) prctile(c1hat_boots_or,97.5)];
                CIwidth=max(CI)-min(CI);
                CIf=[CIf;CI];
                CIfwidth=[CIfwidth;CIwidth];
                
            za=-1.96;
            pp=length(find(c1hat_boots_or<=c1hat))/length(c1hat_boots_or);
            b=norminv(pp);
            r=normcdf(2*b-za);
            upp=prctile(c1hat_boots_or,r*100);
            
            za=1.96;
            pp=length(find(c1hat_boots_or<=c1hat))/length(c1hat_boots_or);
            b=norminv(pp);
            r=normcdf(2*b-za);
            low=prctile(c1hat_boots_or,r*100);
            
            CIbias=[low upp];

            CI=CIbias;
            CIwidth=max(CI)-min(CI);
            CIf=[CIf;CI];
            CIfwidth=[CIfwidth;CIwidth];
            
            disp('The CIs correspond to BC-AN, BC-PB, BC-bias respectively:')
            CI=CIf
            CIwidth=CIfwidth
            
                
    case 'kernels' %4

        ties=0;
            nx=length(x);n1=nx;
            ny=length(y);n2=ny;
            %====ESTIMATE WITH KERNELS:============

            h1=0.9*min(std(xor1),iqr(xor1)/1.34)*length(xor1)^(-0.2);
            h2=0.9*min(std(xor2),iqr(xor2)/1.34)*length(xor2)^(-0.2);
            F1 =@(at) ksdensity(xor1,at,'width',h1,'function','cdf');
            F2 =@(at) ksdensity(xor2,at,'width',h2,'function','cdf');
            Jfun=@(c) -(F1(c)-F2(c));
            [g , gval,  exitflag]=fminsearch(@(c) Jfun(c), 0.5*(mean(xor1)+mean(xor2)) );
            Jhat=-gval;
            chat=g;


            boots=1;
            while boots<=400
                if boots==100 || boots==200 || boots==300
                    boots
                end
            lastwarn('') %check for warnings
            at1=randsample(1:n1,n1,'true'); %set index for sampling with replacement for 1st population
            at2=randsample(1:n2,n2,'true'); %set index for sampling with replacement for 2nd population
            x1boots=xor1(at1); %sample with replacement from x1or, ("or" stands for original sample)
            x2boots=xor2(at2); %sample with replacement from x2or, ("or" stands for original sample) 


            h1=0.9*min(std(x1boots),iqr(x1boots)/1.34)*length(x1boots)^(-0.2);
            h2=0.9*min(std(x2boots),iqr(x2boots)/1.34)*length(x2boots)^(-0.2);
            F1 =@(at) ksdensity(x1boots,at,'width',h1,'function','cdf');
            F2 =@(at) ksdensity(x2boots,at,'width',h2,'function','cdf');
            Jfun=@(c) -(F1(c)-F2(c));
            [g gval exitf]=fminsearch(@(c) Jfun(c), init );
            Jb(boots)=-gval;
            cb(boots)=g;
            if exitf==1
            boots=boots+1;
            end
            end


            chat;
            CI=[chat-1.96*sqrt(var(cb)) chat+1.96*sqrt(var(cb))];
            CIwidth=max(CI)-min(CI);

            CI=[CI;prctile(cb,2.5) prctile(cb,97.5)];
            CIwidth=[CIwidth;prctile(cb,97.5)-prctile(cb,2.5)];

    c1hat=chat;
    
    disp('The CIs correspond to Kernels-AN and Kernels-PB respectively:')
            CI
            CIwidth

     case 'HCNS'
            nx=length(x);n1=nx;
            ny=length(y);n2=ny;
            %====ESTIMATE WITH KERNELS:============
            xx=xor1;yy=xor2;
           
           exitf=1;
            exitflag=1;
            
            [bhat1 Hx1 F1 S1 KMdist1 knots1]=HCNS(xor1, 0.*xor1,0, [], 'auto', 2,[], 'survivor');
            [bhat2 Hx2 F2 S2 KMdist2 knots2]=HCNS(xor2, 0.*xor2,0, [], 'auto', 2,[], 'survivor');
            
            exitf1=strcmp(class(F1),'function_handle');
            exitf2=strcmp(class(F1),'function_handle');
            if exitf1==1 && exitf2==1;exitf=1;else;exitf=0;end
            
            if exitf==0;exitflag=0;end
            if exitf==1
            Jfun=@(c) -(F1(c)-F2(c));
            %init=0.5*(mean(xor1)+mean(xor2));
            [g gval exitflag]=fminsearch(@(c) Jfun(c), init );
            Jhat=-gval;
            chat=g;c1hat=chat;
            Jstarh=(Jhat+1)/2;
            Jstarhat=log(Jstarh/(1-Jstarh));
            end
            
            if exitf==1
            boots=1;
            while boots<=200
                boots;
                if boots==50 || boots==100 || boots==150
                    boots
                end
            lastwarn('') %check for warnings
            at1=randsample(1:n1,n1,'true'); %set index for sampling with replacement for 1st population
            at2=randsample(1:n2,n2,'true'); %set index for sampling with replacement for 2nd population
            x1boots=xx(at1); %sample with replacement from x1or, ("or" stands for original sample)
            x2boots=yy(at2); %sample with replacement from x2or, ("or" stands for original sample) 

            [bhat1 Hx1 F1 S1 KMdist1 knots1]=HCNS(x1boots, 0.*x1boots,0, [], 'auto', 2,[]);
            [bhat2 Hx2 F2 S2 KMdist2 knots2]=HCNS(x2boots, 0.*x2boots,0, [], 'auto', 2,[]);
            
            exitf1=strcmp(class(F1),'function_handle');
            exitf2=strcmp(class(F2),'function_handle');
            exitf1;
            exitf2;
            if exitf1==1 && exitf2==1;exitf=1;else;exitf=0;end
            exitffff=exitf;
            F1;
            F2;
            if exitf==1
            Jfun=@(c) -(F1(c)-F2(c));
            %init=0.5*(mean(xor1)+mean(xor2));
            [g gval exitflag]=fminsearch(@(c) Jfun(c), init );
            Jb(boots)=-gval;
            Jstaro=(Jb(boots)+1)/2;
            Jstar(boots)=log(Jstaro/(1-Jstaro));
            
            cb(boots)=g;
            cb;
       
            
            boots=boots+1;
            elseif exitf==0
            boots=boots;
            end
            
            end

            end

            CIperc=[prctile(cb,2.5) prctile(cb,97.5)];
            CIpercwidth=max(CIperc)-min(CIperc);
            CIpm=[chat-1.96*sqrt(var(cb)) chat+1.96*sqrt(var(cb))];
            CIpmwidth=max(CIpm)-min(CIpm);
            
           
            CI=[CIpm; CIperc];
            CIwidth=[CIpmwidth; CIpercwidth];
            
            disp('The CIs correspond to HCNS-AN and HCNS-PB respectively:')
            CI
            CIwidth
            hist(cb)
            
        
    otherwise
            warning('Unexpected CItype. No CIs calculated.')
end